---
title: "openvpn : passer de Openssl 1.1 à Openssl 3.3 quand on utilise un fichier pks12"
date: 2023-07-23
draft: false
---
Pour me connecter à un VPN via Openvpn, j'utilise un fichier pks12. Ce fichier à été généré via openssl 1.1.
Sous Nixos 22.11, je pouvais utiliser le paquet openvpn_24 qui supportait openssl 1.1, mais depuis la version 23.05, ce paquet n'est plus disponible.

Un seul paquet openvpn est disponible et celui-ci supporte uniquement les credential d'OpenSSL 3.3.

La suite, n'est pas de moi mais de Sylvain.

La page avec l'information initiale : https://github.com/openssl/openssl/issues/20607

Il faut commencer par décomposer son fichier pks12. La commande magique :

    openssl pkcs12 -in cert.p12 -out cert.pem -legacy

A partir de là vous avez la capaciter à avoir tous les fichiers (certificat, clé privé etc..) pour regénérer un pks12.

Pour le regénérer, il faut le faire depuis une machine avec openssl 3.3 (ou avoir fait son upgrade) :

    openssl pkcs12 -export -inkey private.key -in cert -certfile CERT.crt -out nouveau.p12

  * private.key : votre clé privée extraite précédement
  * cert : votre certificat, extrait précédement
  * CERT.crt : le certificat de la boite, lui aussi issue du pks12

et c'est tout ... Faut juste pas oublié qu'il faut faire l'extraction avec l'option **-legacy** et la création avec une version à jour.

